import gleam/dynamic.{type Dynamic}
import gleam/dynamic/decode.{type Decoder}
import gleam/option.{type Option}

pub type SpacetradersError {
  SpacetradersError(
    code: Int,
    message: String,
    data: Option(Dynamic),
    request_id: Option(String),
  )
}

pub fn decoder() -> Decoder(SpacetradersError) {
  use code <- decode.field("code", decode.int)
  use message <- decode.field("message", decode.string)
  use data <- decode.optional_field(
    "data",
    option.None,
    decode.optional(decode.dynamic),
  )
  use request_id <- decode.optional_field(
    "requestId",
    option.None,
    decode.optional(decode.string),
  )
  decode.success(SpacetradersError(code:, message:, data:, request_id:))
}
